/*
 * ToRegExp.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ToRegExp.h"
#include "ToRegExpStateElimination.h"
#include <exception/AlibException.h>

namespace automaton {

namespace convert {

regexp::RegExp ToRegExp::convert(const automaton::Automaton& automaton) {
	return getInstance().dispatch(automaton.getData());
}

regexp::RegExp ToRegExp::convert(const automaton::EpsilonNFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpEpsilonNFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::EpsilonNFA>(ToRegExp::getInstance(), ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const automaton::MultiInitialStateNFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpMultiInitialStateNFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::MultiInitialStateNFA>(ToRegExp::getInstance(), ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const automaton::NFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpNFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::NFA>(ToRegExp::getInstance(), ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const automaton::DFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpDFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::DFA>(ToRegExp::getInstance(), ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const automaton::ExtendedNFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpExtendedNFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::ExtendedNFA>(ToRegExp::getInstance(), ToRegExp::convert);

regexp::RegExp ToRegExp::convert(const automaton::CompactNFA& automaton) {
	return regexp::RegExp(ToRegExpStateElimination::convert(automaton));
}

auto ToRegExpCompactNFA = ToRegExp::RegistratorWrapper<regexp::RegExp, automaton::CompactNFA>(ToRegExp::getInstance(), ToRegExp::convert);

} /* namespace convert */

} /* namespace automaton */
