/*
 * Total.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TOTAL_H_
#define TOTAL_H_

#include <common/multipleDispatch.hpp>
#include "automaton/Automaton.h"

namespace automaton {

namespace simplify {

/**
 * Makes finite automaton's transition function total.
 * Source: Melichar: Algorithm 2.22
 */
class Total : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	/**
	 * Computes epsilon closure of a state in epsilon nonfree automaton
	 */
	static automaton::Automaton total(const automaton::Automaton& automaton);

	static automaton::NFA total(const automaton::NFA& automaton);
	static automaton::DFA total(const automaton::DFA& automaton);

	static Total& getInstance() {
		static Total res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* TOTAL_H_ */
