/*
 * ToRegExp.h
 *
 *  Created on: 4. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef GRAMMAR_TO_REG_EXP_H_
#define GRAMMAR_TO_REG_EXP_H_

#include <common/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/LeftRG.h>

#include <regexp/RegExp.h>

namespace grammar {

namespace convert {

class ToRegExp : public std::SingleDispatch<regexp::RegExp, grammar::GrammarBase> {
public:
	/**
	 * @return regexp equivalent to source right regular grammar.
	 * @param grammar Grammar to convert
	 */
	static regexp::RegExp convert(const grammar::Grammar& grammar);

	static regexp::RegExp convert(const grammar::RightRG& grammar);
	static regexp::RegExp convert(const grammar::LeftRG& grammar);

	static ToRegExp& getInstance() {
		static ToRegExp res;
		return res;
	}
};

} /* namespace covert */

} /* namespace grammar */

#endif /* GRAMMAR_TO_REG_EXP_H_ */
