/*
 * IsLanguageEmpty.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef IS_LANGUAGE_EMPTY_H_
#define IS_LANGUAGE_EMPTY_H_

#include <common/multipleDispatch.hpp>

#include <grammar/Grammar.h>

namespace grammar {

namespace properties {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class IsLanguageEmpty : public std::SingleDispatch<bool, grammar::GrammarBase> {
public:
	static bool isLanguageEmpty( const grammar::Grammar & grammar );

	/*
	 * Melichar 3.6 - decides whether L( grammar ) = \0
	 *
	 * Severals steps implemented in method CFGTransformations::getProductiveNonTerminals();
	 * @see getProductiveNonTerminals
	 */
	template<class T>
	static bool isLanguageEmpty( const T & grammar );

	static IsLanguageEmpty& getInstance() {
		static IsLanguageEmpty res;
		return res;
	}
};

} /* namespace properties */

} /* namespace grammar */

#endif /* IS_LANGUAGE_EMPTY_H_ */
