#ifndef GRAPH_TOPOLOGICAL_SORT_H_
#define GRAPH_TOPOLOGICAL_SORT_H_

#include <common/multipleDispatch.hpp>
#include <list>

#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph {

namespace sort {

class TopologicalSort : public std::SingleDispatch<std::list<Node>, graph::GraphBase> {
public:
	typedef std::list<Node> Result;

	static Result topologicalsort(const Graph &graph);

	static Result topologicalsort(const DirectedGraph &graph);

	static TopologicalSort& getInstance() {
		static TopologicalSort res;
		return res;
	}
};

} // namespace sort

} // namespace graph

#endif // GRAPH_TOPOLOGICAL_SORT_H_
