/*
 * ToGrammar.cpp
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "ToGrammar.h"
#include "ToGrammarRightRGGlushkov.h"
#include <exception/AlibException.h>

namespace regexp {

namespace convert {

grammar::Grammar ToGrammar::convert(const regexp::RegExp& regexp) {
	return getInstance().dispatch(regexp.getData());
}

grammar::Grammar ToGrammar::convert(const regexp::FormalRegExp& regexp) {
	return grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

auto ToGrammarFormalRegExp = ToGrammar::RegistratorWrapper<grammar::Grammar, regexp::FormalRegExp>(ToGrammar::getInstance(), ToGrammar::convert);

grammar::Grammar ToGrammar::convert(const regexp::UnboundedRegExp& regexp) {
	return grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

auto ToGrammarUnboundedRegExp = ToGrammar::RegistratorWrapper<grammar::Grammar, regexp::UnboundedRegExp>(ToGrammar::getInstance(), ToGrammar::convert);

} /* namespace convert */

} /* namespace regexp */
