/*
 * ToGrammar.h
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_TO_GRAMMAR_H_
#define REG_EXP_TO_GRAMMAR_H_

#include <common/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpFeatures.h>

namespace regexp {

namespace convert {

class ToGrammar : public std::SingleDispatch<grammar::Grammar, regexp::RegExpBase> {
public:
	/**
	 * Performs conversion.
	 * @return right regular grammar equivalent to source regexp.
	 */
	static grammar::Grammar convert(const regexp::RegExp& regexp);

	static grammar::Grammar convert(const regexp::FormalRegExp& regexp);
	static grammar::Grammar convert(const regexp::UnboundedRegExp& regexp);

	static ToGrammar& getInstance() {
		static ToGrammar res;
		return res;
	}
};

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_GRAMMAR_H_ */
