/*
 * NormalizeRotation.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _NORMALIZE_ROTATION_H__
#define _NORMALIZE_ROTATION_H__

#include <common/multipleDispatch.hpp>

#include <string/String.h>
#include <string/StringFeatures.h>

namespace string {

namespace simplify {

class NormalizeRotation : public std::SingleDispatch<string::String, string::StringBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static string::String normalize(const string::String& string);

	static string::CyclicString normalize(const string::CyclicString& string);

	static NormalizeRotation& getInstance() {
		static NormalizeRotation res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace string */

#endif /* _NORMALIZE_ROTATION_H__ */
