/*
 * ExactFactorAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_FACTOR_AUTOMATON__H_
#define _EXACT_FACTOR_AUTOMATON__H_

#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>
#include <string/LinearString.h>
#include <string/String.h>
#include <common/multipleDispatch.hpp>

namespace stringology {

namespace exact {

class ExactFactorAutomaton : public std::SingleDispatch<automaton::Automaton, string::StringBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const string::String& text);

	static automaton::EpsilonNFA construct(const string::LinearString& text);

	static ExactFactorAutomaton& getInstance() {
		static ExactFactorAutomaton res;
		return res;
	}
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_FACTOR_AUTOMATON__H_ */
