/*
 * ExactMultiNondeterministicSubsequenceAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MULTI_NONDETERMINISTIC_SUBSEQUENCE_AUTOMATON__H_
#define _EXACT_MULTI_NONDETERMINISTIC_SUBSEQUENCE_AUTOMATON__H_

#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>
#include <string/LinearString.h>
#include <string/String.h>

namespace stringology {

namespace exact {

class ExactMultiNondeterministicSubsequenceAutomaton {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const std::set<string::String>& text);

	static automaton::EpsilonNFA construct(const std::set<string::LinearString>& text);
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_MULTI_NONDETERMINISTIC_SUBSEQUENCE_AUTOMATON__H_ */
