/*
 * ExactSubsequenceAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_SUBSEQUENCE_AUTOMATON__H_
#define _EXACT_SUBSEQUENCE_AUTOMATON__H_

#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>
#include <string/String.h>
#include <common/multipleDispatch.hpp>

namespace stringology {

namespace exact {

class ExactSubsequenceAutomaton : public std::SingleDispatch<automaton::Automaton, string::StringBase> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct(const string::String& text);

	static automaton::DFA construct(const string::LinearString& text);

	static ExactSubsequenceAutomaton& getInstance() {
		static ExactSubsequenceAutomaton res;
		return res;
	}
};

} /* namespace exact */

} /* namespace stringology */

#endif /* _EXACT_SUBSEQUENCE_AUTOMATON__H_ */
