#include "EpsilonClosureTest.h"

#include <automaton/FSM/EpsilonNFA.h>

#include "automaton/properties/EpsilonClosure.h"
#include "automaton/properties/AllEpsilonClosure.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( EpsilonClosureTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( EpsilonClosureTest );

void EpsilonClosureTest::setUp() {
}

void EpsilonClosureTest::tearDown() {
}

void EpsilonClosureTest::testEpsilonClosure() {
	automaton::State q0("q0");
	automaton::State q1("q1");
	automaton::State q2("q2");
	automaton::State q3("q3");
	automaton::State q4("q4");
	automaton::State q5("q5");
	automaton::State q6("q6");
	automaton::State q7("q7");
	automaton::State q8("q8");
	automaton::State q9("q9");

	automaton::EpsilonNFA automaton(q0);
	automaton.setStates({q0, q1, q2, q3, q4, q5, q6, q7, q8, q9});

	automaton.addTransition(q0, q1);
	automaton.addTransition(q1, q2);
	automaton.addTransition(q2, q3);
	automaton.addTransition(q3, q4);
	automaton.addTransition(q4, q1);
	automaton.addTransition(q5, q6);
	automaton.addTransition(q6, q1);
	automaton.addTransition(q8, q8);

	std::map<automaton::State, std::set<automaton::State>> allClosures = automaton::properties::AllEpsilonClosure::allEpsilonClosure(automaton);

	for(const automaton::State& state : automaton.getStates()) {
		CPPUNIT_ASSERT(automaton::properties::EpsilonClosure::epsilonClosure(automaton, state) == allClosures[state]);
	}
}
