/*
 * Alphabet.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "Alphabet.h"

namespace alphabet {

const std::set < alphabet::Symbol > & Alphabet::getAlphabet ( ) const {
	return this->alphabet;
}

void Alphabet::addSymbol ( alphabet::Symbol symbol ) {
	this->alphabet.insert ( std::move ( symbol ) );
}

bool Alphabet::isEmpty ( ) const {
	return this->alphabet.size ( ) == 0;
}

bool Alphabet::operator ==( const Alphabet & other ) const {
	return this->alphabet == other.alphabet;
}

bool Alphabet::operator <( const Alphabet & other ) const {
	return this->alphabet < other.alphabet;
}

std::ostream & operator <<( std::ostream & out, const Alphabet & alphabet ) {
	out << "(Alphabet ";

	for ( const alphabet::Symbol & symbol : alphabet.alphabet )
		out << symbol;

	out << ")";
	return out;
}

} /* namespace alphabet */
