/*
 * SymbolBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_BASE_H_
#define SYMBOL_BASE_H_

#include "../object/ObjectBase.h"

namespace alphabet {

/**
 * Represents symbol in an alphabet.
 */
class SymbolBase : public alib::ObjectBase {
public:
	virtual SymbolBase* clone() const = 0;
	virtual SymbolBase* plunder() && = 0;

	virtual SymbolBase* next() const = 0;
	virtual SymbolBase* inc() && = 0;
};

} /* namespace alphabet */

namespace std {

template<>
struct compare<alphabet::SymbolBase> {
	int operator()(const alphabet::SymbolBase& first, const alphabet::SymbolBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* SYMBOL_BASE_H_ */
