/*
 * AutomatonFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_FEATURES_H_
#define AUTOMATON_FEATURES_H_

namespace automaton {

enum class FEATURES {
	EPSILON_NFA,
	MULTI_INITIAL_STATE_NFA,
	NFA,
	DFA,
	COMPACT_NFA,
	EXTENDED_NFA,
	DPDA,
	SINGLE_POP_DPDA,
	INPUT_DRIVEN_DPDA,
	INPUT_DRIVEN_NPDA,
	VISIBLY_PUSHDOWN_DPDA,
	VISIBLY_PUSHDOWN_NPDA,
	REAL_TIME_HEIGHT_DETERMINISTIC_DPDA,
	REAL_TIME_HEIGHT_DETERMINISTIC_NPDA,
	NPDA,
	SINGLE_POP_NPDA,
	ONE_TAPE_DTM,
	DFTA,
	NFTA
};

class Automaton;
class AutomatonBase;
class State;
enum class Shift;

class EpsilonNFA;
class NFA;
class MultiInitialStateNFA;
class DFA;
class CompactNFA;
class ExtendedNFA;
class DPDA;
class SinglePopDPDA;
class InputDrivenDPDA;
class InputDrivenNPDA;
class VisiblyPushdownDPDA;
class VisiblyPushdownNPDA;
class RealTimeHeightDeterministicDPDA;
class RealTimeHeightDeterministicNPDA;
class NPDA;
class SinglePopNPDA;
class OneTapeDTM;
class DFTA;
class NFTA;

} /* namespace automaton */

#endif /* AUTOMATON_FEATURES_H_ */
