/*
 * BottomOfTheStackSymbolPushdownStoreAlphabet.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbolPushdownStoreAlphabet.h"
#include "../AutomatonException.h"
#include <algorithm>

namespace automaton {

BottomOfTheStackSymbolPushdownStoreAlphabet::BottomOfTheStackSymbolPushdownStoreAlphabet(alphabet::Symbol bottomOfTheStackSymbol) : bottomOfTheStackSymbol(bottomOfTheStackSymbol) {
	addStackSymbol(std::move(bottomOfTheStackSymbol));
}

void BottomOfTheStackSymbolPushdownStoreAlphabet::setBottomOfTheStackSymbol(alphabet::Symbol start) {
	if (!stackAlphabet.count(start)) {
		throw AutomatonException("Stack symbol \"" + (std::string) start + "\" doesn't exist.");
	}

	bottomOfTheStackSymbol = std::move(start);
}

const alphabet::Symbol& BottomOfTheStackSymbolPushdownStoreAlphabet::getBottomOfTheStackSymbol() const {
	return bottomOfTheStackSymbol;
}

} /* namespace automaton */
