/*
 * PushdownStoreAlphabet.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "PushdownStoreAlphabet.h"
#include "../AutomatonException.h"
#include <algorithm>

namespace automaton {

bool PushdownStoreAlphabet::addStackSymbol(alphabet::Symbol symbol) {
	return stackAlphabet.insert(symbol).second;
}

void PushdownStoreAlphabet::setStackAlphabet(std::set<alphabet::Symbol> newSymbols) {
	std::set<alphabet::Symbol> removed;
	std::set_difference(stackAlphabet.begin(), stackAlphabet.end(), newSymbols.begin(), newSymbols.end(), std::inserter(removed, removed.end()));

	for(const alphabet::Symbol& removedSymbol : removed) {
		removeStackSymbol(removedSymbol);
	}

	stackAlphabet = std::move(newSymbols);
}

const std::set<alphabet::Symbol>& PushdownStoreAlphabet::getStackAlphabet() const {
	return stackAlphabet;
}

} /* namespace automaton */
