/*
 * SingleInitialSymbolPushdownStore.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "SingleInitialSymbolPushdownStoreAlphabet.h"
#include "../AutomatonException.h"
#include <algorithm>

namespace automaton {

SingleInitialSymbolPushdownStoreAlphabet::SingleInitialSymbolPushdownStoreAlphabet(alphabet::Symbol initialSymbol) : initialSymbol(initialSymbol) {
	addStackSymbol(std::move(initialSymbol));
}

void SingleInitialSymbolPushdownStoreAlphabet::setInitialSymbol(alphabet::Symbol start) {
	if (!stackAlphabet.count(start)) {
		throw AutomatonException("Stack symbol \"" + (std::string) start + "\" doesn't exist.");
	}

	initialSymbol = std::move(start);
}

const alphabet::Symbol& SingleInitialSymbolPushdownStoreAlphabet::getInitialSymbol() const {
	return initialSymbol;
}

} /* namespace automaton */
