/*
 * Container.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef CONTAINER_H_
#define CONTAINER_H_

#include "../object/WrapperBase.h"
#include "ContainerBase.h"
#include "../common/wrapper.hpp"

namespace container {

/**
 * Wrapper around containers.
 */
class Container : public alib::wrapper<ContainerBase>, public alib::WrapperBase {
	using alib::wrapper<ContainerBase>::wrapper;
};

} /* namespace container */

namespace std {

template<>
struct compare<container::Container> {
	int operator()(const container::Container& first, const container::Container& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* CONTAINER_H_ */

