/*
 * GraphFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: David Rosca
 */

#ifndef GRAPH_H_
#define GRAPH_H_

#include "../object/WrapperBase.h"
#include "GraphBase.h"
#include "../common/wrapper.hpp"

namespace graph {

// Wrapper around graphs.
class Graph : public alib::wrapper<GraphBase>, public alib::WrapperBase {
	using alib::wrapper<GraphBase>::wrapper;
};

} // namespace graph

namespace std {

template<>
struct compare<graph::Graph>
{
	int operator()(const graph::Graph &first, const graph::Graph &second) const
	{
		return first.getData().compare(second.getData());
	}
};

} // namespace

#endif // GRAPH_H_
