/*
 * TerminatingSymbolAlphabet.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TERMINATING_SYMBOL_ALPHABET_H_
#define TERMINATING_SYMBOL_ALPHABET_H_

#include <set>

#include "../../../alphabet/Symbol.h"

namespace indexes {

/**
 * Represents indexes of symbols.
 */
class TerminatingSymbolAlphabet {
protected:
	std::set < alphabet::Symbol > alphabet;

	alphabet::Symbol terminatingSymbol;

public:
	TerminatingSymbolAlphabet ( alphabet::Symbol terminatingSymbol );

	/**
	 * @return List of symbols in the indexes.
	 */
	const std::set < alphabet::Symbol > & getAlphabet ( ) const;

	/**
	 * @param symbol to insert
	 */
	void addSymbol ( alphabet::Symbol symbol );

	/**
	 * Set terminating symbol.
	 * @param terminatingSymbol alphabet::Symbol to set
	 * @throws AlibException when state is not present in the alphabet
	 */
	void setTerminatingSymbol ( alphabet::Symbol terminatinSymbol );

	/**
	 * @return terminating symbol
	 */
	const alphabet::Symbol & getTerminatingSymbol ( ) const;
};

} /* namespace indexes */

#endif /* TERMINATING_SYMBOL_ALPHABET_H_ */
