/*
 * Label.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Martin Zak
 */

#include "Label.h"
#include "PrimitiveLabel.h"
#include "LabelPairLabel.h"
#include "../primitive/Primitive.h"

namespace label {

Label Label::next() const {
	return Label(this->getData().next());
}

void Label::inc() {
	LabelBase* res = std::move(this->getData()).inc();
	if(res == NULL) return;
	this->setData(res);
}

label::Label labelFrom(int number) {
	return label::Label { label::PrimitiveLabel { primitive::primitiveFrom (number) } };
}

label::Label labelFrom(int number1, int number2) {
	return label::Label { label::LabelPairLabel { std::make_pair ( label::Label { label::PrimitiveLabel { primitive::primitiveFrom ( number1 ) } }, label::Label { label::PrimitiveLabel { primitive::primitiveFrom ( number2 ) } } ) } };
}

label::Label labelFrom(char character) {
	return label::Label { label::PrimitiveLabel { primitive::primitiveFrom ( character ) } };
}

label::Label labelFrom(std::string string) {
	return label::Label { label::PrimitiveLabel { primitive::primitiveFrom ( std::move ( string ) ) } };
}

label::Label labelFrom(const char* string) {
	return labelFrom((std::string) string);
}

} /* namespace label */

