/*
 * LabelBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_BASE_H_
#define LABEL_BASE_H_

#include "../object/ObjectBase.h"

namespace label {

/**
 * Represents symbol in an alphabet.
 */
class LabelBase : public alib::ObjectBase {
public:
	virtual LabelBase* clone() const = 0;
	virtual LabelBase* plunder() && = 0;

	virtual LabelBase* next() const = 0;
	virtual LabelBase* inc() && = 0;
};

} /* namespace label */

namespace std {

template<>
struct compare<label::LabelBase> {
	int operator()(const label::LabelBase& first, const label::LabelBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* LABEL_BASE_H_ */

