/*
 * Object.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef OBJECT_H_
#define OBJECT_H_

#include "../object/WrapperBase.h"
#include "ObjectBase.h"
#include "../common/wrapper.hpp"

namespace alib {

/**
 * Wrapper around object.
 */
class Object : public alib::wrapper<ObjectBase>, public alib::WrapperBase {
	using alib::wrapper<ObjectBase>::wrapper;
};

} /* namespace alib */

namespace std {

template<>
struct compare<alib::Object> {
	int operator()(const alib::Object& first, const alib::Object& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* OBJECT_H_ */

