/*
 * ObjectBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef OBJECT_BASE_H_
#define OBJECT_BASE_H_

#include <compare>
#include <memory>
#include <deque>
#include "../common/base.hpp"
#include "../sax/Token.h"

namespace alib {

class ObjectBase : public alib::base<ObjectBase>, public std::cow_shared_ptr_base {
public:
	virtual void compose(std::deque<sax::Token>& out) const = 0;
};

// ----------------------------------------------------------------------------------------------------------------------

} /* namespace alib */

namespace std {

template<>
struct compare<alib::ObjectBase> {
	int operator()(const alib::ObjectBase& first, const alib::ObjectBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* OBJECT_BASE_H_ */
