/*
 * Primitive.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_H_
#define PRIMITIVE_H_

#include "../object/WrapperBase.h"
#include "PrimitiveBase.h"
#include "../common/wrapper.hpp"

namespace primitive {

/**
 * Wrapper around primitive data types.
 */
class Primitive : public alib::wrapper<PrimitiveBase>, public alib::WrapperBase {
	using alib::wrapper<PrimitiveBase>::wrapper;

public:
	Primitive next() const;
	void inc();
};

Primitive primitiveFrom(int number);
Primitive primitiveFrom(char character);
Primitive primitiveFrom(std::string string);
Primitive primitiveFrom(const char* string);
Primitive primitiveFrom(unsigned number);
Primitive primitiveFrom(bool value);

} /* namespace primitive */

namespace std {

template<>
struct compare<primitive::Primitive> {
	int operator()(const primitive::Primitive& first, const primitive::Primitive& second) const {
		return first.getData().compare(second.getData());
	}
};

} /* namespace std */

#endif /* PRIMITIVE_H_ */

