/*
 * PrimitiveBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_BASE_H_
#define PRIMITIVE_BASE_H_

#include "../object/ObjectBase.h"
#include <deque>
#include "../sax/Token.h"

namespace primitive {

/**
 * Represents symbol in an alphabet.
 */
class PrimitiveBase : public alib::ObjectBase {
public:
	virtual PrimitiveBase* clone() const = 0;
	virtual PrimitiveBase* plunder() && = 0;

	virtual void inc() = 0;
};

} /* namespace primitive */

namespace std {

template<>
struct compare<primitive::PrimitiveBase> {
	int operator()(const primitive::PrimitiveBase& first, const primitive::PrimitiveBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* PRIMITIVE_BASE_H_ */

