/*
 * RegExpBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_BASE_H_
#define REG_EXP_BASE_H_

#include "../object/ObjectBase.h"
#include <set>
#include "../alphabet/Symbol.h"

namespace regexp {

/**
 * Represents symbol in an alphabet.
 */
class RegExpBase : public alib::ObjectBase {
public:
	virtual RegExpBase* clone() const = 0;
	virtual RegExpBase* plunder() && = 0;

	virtual const std::set<alphabet::Symbol>& getAlphabet() const = 0;
};

} /* namespace regexp */

namespace std {

template<>
struct compare<regexp::RegExpBase> {
	int operator()(const regexp::RegExpBase& first, const regexp::RegExpBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* REG_EXP_BASE_H_ */

