/*
 * FromXMLParserHelper.h
 *
 *  Created on: Oct 12, 2013
 *      Author: Jan Travnicek
 */

#ifndef FROM_XML_PARSER_HELPER_H_
#define FROM_XML_PARSER_HELPER_H_

#include <deque>
#include "Token.h"

namespace sax {

/**
 * Parser used to get UnknownAutomaton from XML parsed into list of Tokens.
 */
class FromXMLParserHelper {
public:
	static bool isToken(const std::deque<Token>::const_iterator& input, Token::TokenType type, const std::string& data);
	static bool isTokenType(const std::deque<Token>::const_iterator& input, Token::TokenType type);
	static void popToken(std::deque<Token>::iterator& input, Token::TokenType type, const std::string& data);
	static std::string popTokenData(std::deque<Token>::iterator& input, Token::TokenType type);
	static std::string getTokenData(const std::deque<Token>::const_iterator& input, Token::TokenType type);

};

} /* namespace sax */

#endif /* FROM_XML_PARSER_HELPER_H_ */

