/*
 * StringFromXMLParser.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "StringFromXMLParser.h"
#include "../../sax/FromXMLParserHelper.h"
#include "../../XmlApi.hpp"

namespace string {

std::set<alphabet::Symbol> StringFromXMLParser::parseAlphabet(std::deque<sax::Token>::iterator& input) {
	std::set<alphabet::Symbol> alphabet;
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, "alphabet");
	while (sax::FromXMLParserHelper::isTokenType(input, sax::Token::TokenType::START_ELEMENT)) {
		alphabet.insert(alib::xmlApi<alphabet::Symbol>::parse(input));
	}
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, "alphabet");
	return alphabet;
}

std::vector<alphabet::Symbol> StringFromXMLParser::parseContent(std::deque<sax::Token>::iterator& input) {
	std::vector<alphabet::Symbol> data;
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, "content");
	while (sax::FromXMLParserHelper::isTokenType(input, sax::Token::TokenType::START_ELEMENT)) {
		data.push_back(alib::xmlApi<alphabet::Symbol>::parse(input));
	}
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, "content");
	return data;
}

} /* namespace string */
