/*
 * RankedPatternAlphabet.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef RANKED_PATTERN_ALPHABET_H_
#define RANKED_PATTERN_ALPHABET_H_

#include "RankedAlphabet.h"

namespace tree {

/**
 * Abstract base class for all strings. Contains common elements of strings.
 */
class RankedPatternAlphabet : public RankedAlphabet {
protected:
	alphabet::RankedSymbol subtreeWildcard;

public:
	RankedPatternAlphabet(alphabet::RankedSymbol subtreeWildcard);

	/**
	 * Sets the subtree variable = symbol representing subtree substitution place in the pattern
	 * @param symbol Symbol to set
	 */
	void setSubtreeWildcard(alphabet::RankedSymbol symbol);

	/**
	 * @return symbol representing subtree variable
	 */
	const alphabet::RankedSymbol& getSubtreeWildcard() const;

};

} /* namespace tree */

#endif /* RANKED_PATTERN_ALPHABET_H_ */

