/*
 * UnrankedAlphabet.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "UnrankedPatternAlphabet.h"
#include "../TreeException.h"

#include <algorithm>

namespace tree {

UnrankedPatternAlphabet::UnrankedPatternAlphabet(alphabet::Symbol subtreeWildcard) : subtreeWildcard(subtreeWildcard) {
	alphabet.insert(std::move(subtreeWildcard));
}

void UnrankedPatternAlphabet::setSubtreeWildcard(alphabet::Symbol symbol) {
	if (!alphabet.count(symbol))
		throw TreeException("Subtree wildcard symbol \"" + (std::string) symbol + "\" is not in the alphabet.");

	subtreeWildcard = std::move(symbol);

}

const alphabet::Symbol& UnrankedPatternAlphabet::getSubtreeWildcard() const {
	return subtreeWildcard;
}

} /* namespace tree */

