/*
 * UsefullStates.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef EFFICIENT_USEFULL_STATES_H_
#define EFFICIENT_USEFULL_STATES_H_

#include <common/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include <automaton/common/State.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace properties {

namespace efficient {

class UsefullStates : public std::SingleDispatch<std::set<automaton::State>, automaton::AutomatonBase> {
public:
	static std::set<automaton::State> usefullStates( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.32
	 */
	template<class T>
	static std::set<automaton::State> usefullStates( const T & fsm );

	static UsefullStates& getInstance() {
		static UsefullStates res;
		return res;
	}
};

} /* namespace efficient */

} /* namespace properties */

} /* namespace automaton */

#endif /* EFFICIENT_USEFULL_STATES_H_ */
