/*
 * TreeFromRawParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_RAW_PARSER
#define TREE_FROM_RAW_PARSER

#include "sax/FromXMLParserHelper.h"
#include "tree/TreeFeatures.h"
#include <set>

namespace tree {

class TreeFromRawParser : public sax::FromXMLParserHelper {
public:
	TreeFromRawParser() {}

	Tree parseTree(std::deque<sax::Token>::iterator& input) const;
	Tree parseTree(std::deque<sax::Token>::iterator& input, const std::set<FEATURES>& features) const;

private:
	UnrankedNode* parseContent(std::deque<sax::Token>::iterator& input) const;
	UnrankedNode* parseContentLeaf(std::deque<sax::Token>::iterator& input) const;
};

} /* namespace tree */

#endif /* TREE_FROM_RAW_PARSER */
