/*
 * clone.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef CLONE_HPP_
#define CLONE_HPP_

namespace std {

template<class T> struct has_clone {
	typedef char (&Yes)[1];
	typedef char (&No)[2];

	template<class U>
	static Yes test(U * data, typename std::enable_if< std::is_pointer<decltype(data->clone())>::value>::type * = 0);
	static No test(...);
	static const bool value = sizeof(Yes) == sizeof(has_clone::test((typename std::remove_reference<T>::type*)0));
};

template<class T, typename std::enable_if< ! std::has_clone<T>::value >::type* = nullptr>
T* clone(const T* tmp) {
	return new T(*tmp);
}

template<class T, typename std::enable_if< std::has_clone<T>::value >::type* = nullptr>
T* clone(const T* tmp) {
	return tmp->clone();
}

} /* namespace std */

#endif /* CLONE_HPP_ */
