#include "ChronoTest.h"
#include <chrono>
#include <thread>
#include <cmath>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ChronoTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( ChronoTest );

void ChronoTest::setUp() {
}

void ChronoTest::tearDown() {
}

void ChronoTest::testChrono1() {
	std::chrono::measure_duration tmp;
	tmp.start();
	tmp.end();

	std::cout << tmp.duration() << std::endl;

	auto elapsed = std::chrono::duration_cast<std::chrono::microseconds>(tmp.duration());
	std::cout << elapsed << std::endl;
}

void ChronoTest::testChrono2() {
	std::chrono::measurements meas;
	meas.start("global", std::chrono::measurements::Type::OVERALL);

		std::chrono::measurements::start("init", std::chrono::measurements::Type::INIT);
			std::this_thread::sleep_for(std::chrono::milliseconds(100));
		std::chrono::measurements::end();

		std::chrono::measurements::start("main", std::chrono::measurements::Type::MAIN);
			std::this_thread::sleep_for(std::chrono::milliseconds(20));
			std::chrono::measurements::start("aux", std::chrono::measurements::Type::AUXILARY);
				std::this_thread::sleep_for(std::chrono::milliseconds(40));
			std::chrono::measurements::end();
			std::this_thread::sleep_for(std::chrono::milliseconds(80));
			std::chrono::measurements::start("aux", std::chrono::measurements::Type::AUXILARY);
				std::this_thread::sleep_for(std::chrono::milliseconds(40));
			std::chrono::measurements::end();
			std::this_thread::sleep_for(std::chrono::milliseconds(80));
		std::chrono::measurements::end();

		std::chrono::measurements::start("fin", std::chrono::measurements::Type::FINALIZE);
			std::this_thread::sleep_for(std::chrono::milliseconds(30));
			std::chrono::measurements::start("aux", std::chrono::measurements::Type::AUXILARY);
				std::this_thread::sleep_for(std::chrono::milliseconds(40));
			std::chrono::measurements::end();
			std::this_thread::sleep_for(std::chrono::milliseconds(80));
		std::chrono::measurements::end();
	std::chrono::measurements::end();

	std::cout << "Default print" << std::endl << std::chrono::measurements::results() << std::endl;
	auto sum1 = std::get<3>(std::chrono::measurements::results()[1]) + std::get<3>(std::chrono::measurements::results()[2]) + std::get<3>(std::chrono::measurements::results()[3]);
	auto exp1 = std::get<2>(std::chrono::measurements::results()[3]);

	CPPUNIT_ASSERT(std::abs(sum1.count() - exp1.count()) < 2000);

	auto sum2 = std::get<3>(std::chrono::measurements::results()[0]) + std::get<3>(std::chrono::measurements::results()[1]) + std::get<3>(std::chrono::measurements::results()[2]) + std::get<3>(std::chrono::measurements::results()[3]) + std::get<3>(std::chrono::measurements::results()[4]) + std::get<3>(std::chrono::measurements::results()[5]);
	auto exp2 = std::get<2>(std::chrono::measurements::results()[6]);

	CPPUNIT_ASSERT(std::abs(sum2.count() - exp2.count()) < 2000);

	std::cout << "Tree print" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print none" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::NONE << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print all - main" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::ALL << std::chrono::measurements::Filter::NO_MAIN << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print all - overall" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::ALL << std::chrono::measurements::Filter::NO_OVERALL << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print all - overall, main" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::ALL << std::chrono::measurements::Filter::NO_OVERALL << std::chrono::measurements::Filter::NO_MAIN << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print all - overall, main, finalize" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::ALL << std::chrono::measurements::Filter::NO_OVERALL << std::chrono::measurements::Filter::NO_MAIN << std::chrono::measurements::Filter::NO_FINALIZE << std::chrono::measurements::results() << std::endl;
	std::cout << "Tree print none + overall" << std::endl << std::chrono::measurements::Format::TREE << std::chrono::measurements::Filter::NONE << std::chrono::measurements::Filter::OVERALL << std::chrono::measurements::results() << std::endl;
}

