#include "CompareTest.h"
#include <set>
#include <vector>
#include <pair>


CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( CompareTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( CompareTest );

void CompareTest::setUp() {
}

void CompareTest::tearDown() {
}

void CompareTest::testCompare() {
	std::vector<int> vector1 {1, 2, 3};
	std::vector<int> vector2 {2, 3, 4};

	std::compare<std::vector<int>> comp1;
	CPPUNIT_ASSERT(comp1(vector1, vector2) < 0);

	std::set<std::vector<int>> set1 {vector1};
	std::set<std::vector<int>> set2 {vector2};

	std::compare<std::set<std::vector<int>>> comp2;
	CPPUNIT_ASSERT(comp2(set1, set2) < 0);

	std::pair<std::set<std::vector<int>>, std::set<std::vector<int>>> pair1 {set1, set2};
	std::pair<std::set<std::vector<int>>, std::set<std::vector<int>>> pair2 {set2, set1};

	std::compare<std::pair<std::set<std::vector<int>>, std::set<std::vector<int>>>> comp3;
	CPPUNIT_ASSERT(comp3(pair1, pair2) < 0);
}

