#ifndef TYPE_TRAITS_TEST_H_
#define TYPE_TRAITS_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class TypeTraitsTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( TypeTraitsTest );
  CPPUNIT_TEST( testIsBaseOf );
  CPPUNIT_TEST_SUITE_END();

public:
struct test {
	int * holder;

	test() {
		//std::cout << "test()" << std::endl;
		holder = new int();
	}

	test(test&& old) : holder(nullptr) {
		//std::cout << "test(test&&)" << std::endl;
		std::swap(holder,old.holder);
	}

	test(const test& old) {
		  //std::cout << "test(const test&)" << std::endl;
		  holder = new int(*old.holder);
	}

	~test()
	{
		//std::cout << "~test()" << std::endl;
		delete holder;
	}

	bool operator<(const test& other) const {
		return *(this->holder) < *(other.holder);
	}

	bool operator==(const test& other) const {
		return *(this->holder) == *(other.holder);
	}

	int compare(const test& other) const {
		return *(this->holder) - *(other.holder);
	}

	friend std::ostream& operator<<(std::ostream& out, const test& other) {
		out << *(other.holder);
		return out;
	}
};

struct test2 {
	int i;

	test2(int i) : i(i) {}
};

public:
  void setUp();
  void tearDown();

  void testIsBaseOf();
};

#endif  // TYPE_TRAITS_TEST_H_
