#ifndef VARIANT_TEST_H_
#define VARIANT_TEST_H_

#include <cppunit/extensions/HelperMacros.h>
#include <compare>

class VectorTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( VectorTest );
  CPPUNIT_TEST( testVector );
  CPPUNIT_TEST( testProperties );
  CPPUNIT_TEST_SUITE_END();

public:
struct test {
	int i;

	test(int i) : i(i) {}

	int get() const {
		return i;
	}
};

public:
  void setUp();
  void tearDown();

  void testVector();
  void testProperties();
};


namespace std {

template<>
struct compare<VectorTest::test> {
	int operator()(const VectorTest::test& first, const VectorTest::test& second) {
		return first.get() - second.get();
	}
};

} /* namespace std */
#endif  // VARIANT_TEST_H_
