/*
 * SymbolFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FROM_STRING_PARSER_H_
#define SYMBOL_FROM_STRING_PARSER_H_

#include "SymbolFromStringLexer.h"
#include "alphabet/SymbolFeatures.h"
#include <set>

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace alphabet {

class SymbolFromStringParser {
public:
	SymbolFromStringParser() {};

private:
	SymbolFromStringLexer m_SymbolLexer;

	Symbol parseSymbol(std::istream&, const std::set<FEATURES>& features) const;
	Symbol parseSymbol(std::istream&) const;

	template<typename T> friend struct alib::stringApi;
};

} /* namespace alphabet */

#endif /* SYMBOL_FROM_STRING_PARSER_H_ */
