/*
 * RegExpFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_LEXER_H_
#define REG_EXP_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace regexp {

class RegExpFromStringLexer {
public:
	enum class TokenType {
		LPAR,
		RPAR,
		PLUS,
		STAR,
		EPS,
		EMPTY,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_LEXER_H_ */
