/*
 * AutomataStat.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef AUTOMATA_STAT_H_
#define AUTOMATA_STAT_H_

#include <common/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include "automaton/Automaton.h"
#include <automaton/common/State.h>

#include "AutomataSettings.h"

class AutomataStat : public std::SingleDispatchLastStaticParam<void, automaton::AutomatonBase, const AutomataSettings&> {
public:
	static void stat(const automaton::Automaton& automaton, const AutomataSettings& settings);

	static void stat(const automaton::NFA& automaton, const AutomataSettings& settings);
	static void stat(const automaton::DFA& automaton, const AutomataSettings& settings);

	static AutomataStat& getInstance() {
		static AutomataStat res;
		return res;
	}
};

#endif /* AUTOMATA_STAT_H_ */
